﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="monitor.aspx.cs" Inherits="monitor" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <style type="text/css">
        *
        {
            font-size: 12px;
            font-family: Courier New;
        }
        .tab
        {
            border-left: solid 1px black;
            border-top: solid 1px black;
            font-size: 12px;
            font-family: Courier New;
        }
        .header
        {
            background-color: #CCCCCC;
            height: 24px;
        }
        .row_normal
        {
            height: 24px;
            background-color: Write;
            color: Black;
        }
        .row_alert
        {
            height: 24px;
            background-color: #CC0000;
            color: White;
        }
        .id
        {
            width: 100px;
            border-right: solid 1px black;
            border-bottom: solid 1px black;
            padding: 4px;
        }
        .name
        {
            width: 200px;
            border-right: solid 1px black;
            border-bottom: solid 1px black;
            padding: 4px;
        }
        .comment
        {
            width: 200px;
            border-right: solid 1px black;
            border-bottom: solid 1px black;
            padding: 4px;
        }
        .time
        {
            width: 200px;
            border-right: solid 1px black;
            border-bottom: solid 1px black;
            padding: 4px;
        }
    </style>

    <script language="javascript" type="text/javascript">

	    function FormatNumber(num,length)
	    {
		    var s=num.toString();
		    var zero="";
		    for(var i=0;i<length-s.length;i++) zero+="0";
		    return zero+s;
	    }
	    
	    function DateToString(date)
	    {
		    return String.format(
			    "{0}-{1}-{2} {3}:{4}:{5}",
			    FormatNumber(date.getFullYear(),4),
			    FormatNumber(date.getMonth()+1,2),
			    FormatNumber(date.getDate(),2),
			    FormatNumber(date.getHours(),2),
			    FormatNumber(date.getMinutes(),2),
			    FormatNumber(date.getSeconds(),2)
		    );
	    }
	    
        function CreateHttpRequest()
        {
            var request = null;
            if (window.XMLHttpRequest)
            {
                request = new XMLHttpRequest();
            }
            else if (window.ActiveXObject)
            {
                request = new ActiveXObject("Microsoft.XMLHttp");
            }
            return request;
        }

        String.format = function(fmt)
        {
            var params = arguments;
            var pattern = /{{|{[1-9][0-9]*}|\x7B0\x7D/g;
            return fmt.replace(
		        pattern,
		        function(p)
		        {
		            if (p == "{{") return "{";
		            return params[parseInt(p.substr(1, p.length - 2), 10) + 1]
		        }
	        );
        }
        function ShowLockers()
        {
            var request = CreateHttpRequest();
            request.onreadystatechange = function()
            {
                if (request.readyState == 4)
                {
                    try
                    {
                        switch (request.status)
                        {
                            case 200:
                                {
                                    var ret = eval(request.responseText);
                                    var lockers=ret.Lockers;
                                    var now=ret.Now;
                                    var builder = [];
                                    builder.push("<table class='tab' cellspacing='0'><tbody>");
                                    builder.push(String.format("<tr class='header'><td class='id'>ID</td><td class='name'>Name</td><td class='comment'>Comment</td><td class='time'>LockTime</td></tr>"));
                                    for (var i in lockers)
                                    {
                                        var locker = lockers[i];
                                        builder.push(
                                            String.format(
                                                "<tr class='{4}'><td class='id'> - </td><td class='name'>{1}</td><td class='comment'>{2}</td><td class='time'>{3}</td></tr>",
                                                0, 
                                                locker.Name, 
                                                locker.Comment,
                                                DateToString(locker.LockTime),
                                                (now-locker.LockTime)>60000?"row_alert":"row_normal"
                                            )
                                        );
                                    }
                                    builder.push("</tbody></table>");
                                    document.getElementById("currentTime").innerHTML =String.format("CurrentTime:{0}",DateToString(ret.Now));
                                    document.getElementById("lockers").innerHTML = builder.join("");
                                    document.getElementById("threads").innerHTML=String.format("WorkerThreads:{0},CompletionPortThreads:{1}",ret.WorderThreads,ret.CompletionPortThreads);
                                    if(ret.Trace.length>0)
                                    {
                                        var ts=[];
                                        for(var i in ret.Trace)
                                        {
                                            ts.push(String.format("<div>{0}</div>",ret.Trace[i]));
                                        }
                                        var trace = document.getElementById("trace");
                                        trace.innerHTML=document.getElementById("trace").innerHTML+ts.join("");
                                        trace.childNodes[trace.childNodes.length-1].scrollIntoView();
                                    }
                                    break;
                                }
                            default:
                                {
                                    break;
                                }
                        }
                    }
                    catch(ex)
                    {
                        request = null;
                    }
                    setTimeout(ShowLockers,1000);
                }
            }
            request.open("POST", "System.aspx", true);
            request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            request.setRequestHeader("Cache-Control", "no-cache");
            request.send("Command=Monitor");
        }

        window.onload = function()
        {
            ShowLockers();
        }
    </script>

</head>
<body>
    <br />
    <div id="currentTime">
    </div>
    <br />
    <hr />
    <br />
    <div id="threads">
    </div>
    <br />
    <hr />
    <br />
    <div>Lock</div>
    <br />
    <div id="lockers">
    </div>
    <br />
    <hr />
    <br />
    <div>Trace</div>
    <br />
    <div id="trace" style="height:400px; overflow:auto; border:solid 1px #ACA899">
    </div>
</body>
</html>
