if(!TESTING)
{
    System.Link("StyleSheet", Module.GetResourceUrl("IM.css"), "text/css");
}

var Controls = null, CommonDialog = null, IO = null, Communication = null, Management = null;
var Window = null, Control = null, RichEditor = null;

function init(completeCallback, errorCallback)
{
    function LoadModulesComplete()
    {
        IO = System.GetModule("IO.js");
        Communication = System.GetModule("Communication.js");
        Management = System.GetModule("Management.js");
        Controls = System.GetModule("Controls.js");
        CommonDialog = System.GetModule("CommonDialog.js");

        Window = System.GetModule("Window.js").Window;
        Control = System.GetModule("Controls.js").Control;
        
        RichEditor = System.GetModule("RichEditor.js").RichEditor;

        _init(completeCallback, errorCallback);
    }

    System.LoadModules(
        LoadModulesComplete,
        errorCallback,
        ["IO.js", "Communication.js", "Management.js", "Window.js", "Controls.js", "CommonDialog.js", "RichEditor.js"]
    );
}

function _init(completeCallback, errorCallback)
{
    try
    {
        //初始化代码，初始化完成后必须调用completeCallback;
        /*IO.File.Open(
        function(file)
        {
            try
            {
                Config = (file.Content == "" ? DefaultConfig: System.ParseJson(file.Content));
            }
            catch(ex)
            {
                Config = DefaultConfig;
            }
            PreConfig = System.RenderJson(Config);
        
            MessageListener = System.GetModule("Communication.js").MessageListener;
            FriendManager.Initialize(completeCallback, errorCallback);
        },
        function(ex)
        {
            errorCallback(ex);
        },
        ConfigFilePath, true, "utf-8");*/
        
        Config = {};
        PreConfig = System.RenderJson(Config);
        
        MessageListener = System.GetModule("Communication.js").MessageListener;
        FriendManager.Initialize(completeCallback, errorCallback);
    }
    catch (ex)
    {
        errorCallback(new Exception(ex.mame, ex.message));
    }
}



function dispose(completeCallback, errorCallback)
{
    _dispose(completeCallback, errorCallback);
}

function _dispose(completeCallback, errorCallback)
{
    try
    {
        //卸载代码，卸载完成后必须调用completeCallback;
        /*var cs = System.RenderJson(Config);
        if (PreConfig != cs)
        {
            IO.File.Create(
            function()
            {
                completeCallback();
            },
            function(ex)
            {
                errorCallback(ex);
            },
            ConfigFilePath, cs, "utf-8");
        }
        else
        {
            completeCallback();
        }*/
        
        completeCallback();
    }
    catch (ex)
    {
        errorCallback(new Exception(ex.mame, ex.message));
    }
}

//共享全局变量和函数，在此定义的变量和函数将由该应用程序的所有实例共享
function GenerateAnonymusChatCode()
{
    var code = "";
    for (var i = 0; i < 32; i++)
    {
        var num = Math.round(Math.random() * 100000) + (new Date()).getTime();
        code += String.fromCharCode((num % 26) + 65);
    }
    return code;
}

//格式化数字
function FormatNumber(num, length)
{
    var s = num.toString();
    var zero = "";
    for (var i = 0; i < length - s.length; i++) zero += "0";
    return zero + s;
}

//时间转字符串
function DateToString(date)
{
    return String.format("{0}-{1}-{2} {3}:{4}:{5}", FormatNumber(date.getFullYear(), 4), FormatNumber(date.getMonth() + 1, 2), FormatNumber(date.getDate(), 2), FormatNumber(date.getHours(), 2), FormatNumber(date.getMinutes(), 2), FormatNumber(date.getSeconds(), 2));
}

//消息处理
function TranslateMessage(msg)
{
    msg = msg.replace(/<img [^\t\n\r\f\v<>]+>/ig,
    function(img)
    {
        return img.replace(/src=\x22[^\t\n\r\f\v\x22]+\x22/ig,
        function(src)
        {
            return src.replace(/download.aspx\x3FFileName=([^\x22\s]+)/ig,
            function(filename, path)
            {
                return String.format("download.aspx?FileName={{Accessory type=\"image\" src=\"{0}\"}", path);
            })
        });
    });
    msg = msg.replace(/<a [^\t\n\r\f\v<>]+[^\x2F]>/ig,
    function(a)
    {
        var hrefReg = /href=\x22[^\t\n\r\f\v\x22]+\x22/ig
        hrefReg.lastIndex = 0;
        var href = hrefReg.exec(a);
        return String.format("[A:{0}]", href != null && href.length > 0 ? escape(href[0].substr(6, href[0].length - 7)) : "");
    });
    msg = msg.replace(/<\x2Fa>/ig,
    function(a)
    {
        return "[/A]";
    });
    msg = msg.replace(/\x5BFILE\x3A[^\n\f\r\t\v]+\x5D/g,
    function(file)
    {
        return String.format("[FILE:{{Accessory type=\"file\" src=\"{0}\"}]", escape(file.substr(6, file.length - 7)));
    });
    msg = msg.replace(/<!--[^\n\f\r\t\v<>]*-->/g,
    function()
    {
        return "";
    });
    return msg;
}

//好友信息管理类
function FriendManagerCtor()
{
    var This = this;

    var m_Firends = [];
    var m_FirendIndex = {};

    This.GetAllFriends = function()
    {
        return m_Firends;
    }

    This.GetFriendInfo = function(name)
    {
        return m_FirendIndex[name.toUpperCase()];
    }

    This.OnChanged = new Delegate();

    function OnChanged(type, data)
    {
        if (type == "FriendInfo")
        {
            m_Firends = data;
            m_FirendIndex = {};
            for (var i = 0; i < m_Firends.length; i++)
            {
                m_FirendIndex[m_Firends[i].Name.toUpperCase()] = m_Firends[i];
            }
            This.OnChanged.Call(m_Firends);
        }
    }

    //初始化
    This.Initialize = function(callback, errorCallback)
    {
        Management.Management.OnChanged.Attach(OnChanged);
        Management.Management.GetFriends(
        function(fs)
        {
            m_Firends = fs;
            m_FirendIndex = {};
            for (var i = 0; i < m_Firends.length; i++)
            {
                m_FirendIndex[m_Firends[i].Name.toUpperCase()] = m_Firends[i];
            }
            callback(fs);
        },
        errorCallback);
    }

    //销毁
    This.Dispose = function()
    {
        Management.Management.OnChanged.Detach(OnChanged);
    }

}

//消息缓存管理
function MessageCacheCtor()
{
    var This = this;
    var m_Msgs = [];
    var m_Listener = {};

    function AddListener(owner)
    {
        var key = owner.toUpperCase();
        if (Config[key] == undefined) Config[key] = {};
        if (Config[key].LastReceiveTime == undefined)
        {
            Config[key].LastReceiveTime = new Date(2009, 1, 1);
        }
        var listener = new MessageListener(owner, 0, 0, MessageListenerHandler);
        m_Listener[key] = listener;
        listener.Start();
    }

    This.Start = function()
    {
        AddListener(System.GetUser());

        var friends = FriendManager.GetAllFriends();
        for (var key in friends)
        {
            var friend = friends[key];
            if (friend.Type == 1)
            {
                AddListener(friend.Name);
            }
        }
    }

    This.Stop = function()
    {
        for (var key in m_Listener)
        {
            m_Listener[key].Stop();
        }
        m_Listener = {};
    }

    FriendManager.OnChanged.Attach(
    function(friends)
    {
        var friendIndex = {};
        for (var i in friends)
        {
            friendIndex[friends[i].Name.toUpperCase()] = friends[i];
        }
        //删除非好友的消息监听
        var removeKeys = [];
        for (var key in m_Listener)
        {
            if (friendIndex[key] == undefined && key != System.GetUser().toUpperCase())
            {
                m_Listener[key].Stop();
                removeKeys.push(key);
            }
        }
        for (var i in removeKeys)
        {
            delete m_Listener[removeKeys[i]];
        }
        //监听新增好友消息
        for (var key in friendIndex)
        {
            if (friendIndex[key].Type == 1 && m_Listener[key] == undefined)
            {
                AddListener(key);
            }
        }
    });

    This.AddMessages = function(form)
    {
        var receiver = form.GetReceiver();

        for (var i = 0; i < m_Msgs.length; i++)
        {
            var msg = m_Msgs[i];
            if (msg.SenderID == Me.ID)
            {
                if (msg.ReceiverID == receiver.ID) form.AddMessage(msg);
            }
            else if (msg.ReceiverID == Me.ID)
            {
                if (msg.SenderID == receiver.ID) form.AddMessage(msg);
            }
            else
            {
                if (msg.ReceiverID == receiver.ID) form.AddMessage(msg);
            }
        }
    }

    function MessageListenerHandler(ret)
    {
        if (m_Listener[ret.Owner.toUpperCase()] == undefined)
        {
            return;
        }

        var notifyForms = {};
        ret.Messages.sort(
        function(item1, item2)
        {
            if (item1.CreatedTime > item2.CreatedTime) return 1;
            if (item1.CreatedTime < item2.CreatedTime) return - 1;
            return 0;
        });

        if (ret.Messages.length > 0)
        {
            Config[ret.Owner.toUpperCase()].LastReceiveTime = ret.Messages[ret.Messages.length - 1].CreatedTime;
        }

        for (var i = 0; i < ret.Messages.length; i++)
        {
            try
            {
                var msg = ret.Messages[i];
                if (msg.SenderID == Me.ID)
                {
                    /*var exist = ChatFormManager.IsExist(msg.Receiver);
                    var chatForm = ChatFormManager.CreateChatForm(msg.Receiver);
                    if (chatForm != null)
                    {
                        chatForm.AddMessage(msg)
                        notifyForms[msg.Receiver] = chatForm;
                    }*/
                }
                else if (msg.ReceiverID == Me.ID)
                {
                    //收到的消息
                    var exist = ChatFormManager.IsExist(msg.Receiver);
                    var chatForm = ChatFormManager.CreateChatForm(msg.Sender);
                    if (chatForm != null)
                    {
                        chatForm.AddMessage(msg)
                        notifyForms[msg.Sender] = chatForm;
                    }
                }
                else
                {
                    //收到的消息
                    var exist = ChatFormManager.IsExist(msg.Receiver);
                    var chatForm = ChatFormManager.CreateChatForm(msg.Receiver);
                    if (chatForm != null)
                    {
                        chatForm.AddMessage(msg);
                        notifyForms[msg.Sender] = chatForm;
                    }
                }
                m_Msgs.push(msg);
            }
            catch(ex)
            {}
        }
        for (var k in notifyForms)
        {
            notifyForms[k].Notify();
        }
    }
}

//聊天窗口管理类
function ChatFormManagerCtor()
{
    var m_AllForms = {};
    var This = this;

    This.CreateChatForm = function(name)
    {
        var receiver = FriendManager.GetFriendInfo(name);
        if (receiver != null)
        {
            var key = receiver.Name.toUpperCase();
            var chatForm = m_AllForms[key];
            if (chatForm == undefined)
            {
                chatForm = receiver.Type == 0 ? new UserChatForm(receiver) : new GroupChatForm(receiver);
                chatForm.Resize(550, 550, true);
                chatForm.MoveEx('center', -150, 0, true);
                m_AllForms[key] = chatForm;
                chatForm.OnClosed.Attach(
                function(form)
                {
                    ChatFormManager.Remove(form);
                });
                MessageCache.AddMessages(chatForm);
            }
            return chatForm;
        }
        else
        {
            var key = name.toUpperCase();
            var chatForm = m_AllForms[key];
            if (chatForm == undefined)
            {
                chatForm = new UserChatForm({
                    Name: name,
                    Nickname: name
                });
                chatForm.Resize(550, 550, true);
                chatForm.MoveEx('center', -150, 0, true);
                m_AllForms[key] = chatForm;
                chatForm.OnClosed.Attach(
                function(form)
                {
                    ChatFormManager.Remove(form);
                });
                MessageCache.AddMessages(chatForm);
            }
            return chatForm;
        }
    }

    This.Remove = function(form)
    {
        delete m_AllForms[form.GetReceiver().Name.toUpperCase()];
    }

    This.Initialize = function()
    {
        m_AllForms = {};
    }

    This.IsExist = function(name)
    {
        var receiver = FriendManager.GetFriendInfo(name);
        if (receiver != null)
        {
            var key = receiver.Name.toUpperCase();
            return m_AllForms[key] != undefined;
        }
    }

    This.Dispose = function()
    {
        var forms = [];
        for (var key in m_AllForms) forms.push(m_AllForms[key]);
        for (var i = 0; i < forms.length; i++) forms[i].Close();
    }

    This.CloseInvalidForms = function()
    {
        var invalidForms = [];
        for (var key in m_AllForms)
        {
            var form = m_AllForms[key];
            var receiver = form.GetReceiver();
            var info = FriendManager.GetFriendInfo(receiver.Name);
            if (info == undefined || info == null) invalidForms.push(form);
        }
        for (var i in invalidForms) invalidForms[i].Close();

    }
}

var m_AddFriendForm = null;

function ShowAddFriendForm()
{
    if (m_AddFriendForm == null)
    {
        m_AddFriendForm = new AddFriendForm();
        m_AddFriendForm.MoveEx("center", 0, 0);
        m_AddFriendForm.OnClosed.Attach(
        function()
        {
            m_AddFriendForm = null;
        });
    }
    m_AddFriendForm.Show(true);
    return m_AddFriendForm;
}

//好友管理
var FriendManager = new FriendManagerCtor();

//聊天窗口管理
var ChatFormManager = new ChatFormManagerCtor();

//消息缓存管理
var MessageCache = null;

//配置文件路径
var ConfigFilePath = System.GetSpecialDirectory("Config") + "/A553B162-F95F-4B13-BFCD-606DABFDD71F.conf";
//配置
var Config = {};
//缺省配置
var DefaultConfig = {};
//当前配置文件内容
var PreConfig = "";

//当前用户信息
var Me = System.GetUserInfo();

//应用程序引用，这里使用共享变量，只允许启动一个IM
var Instance = null;

var MessageListener = null;

function Application()
{
    var CurrentApplication = this;
    var m_MainForm = null;
    
    //应用程序全局对象;
    this.StartChatWith = function(name)
    {
        m_MainForm.ChatWith(name);
    }
    
    this.ShowMainForm = function()
    {
        m_MainForm.Show(true);
    }
    
    //消息管理器
    var MsgManagmentForm = null;
    
    this.OpenMessages = function(user)
    {
        if (MsgManagmentForm == null)
        {
            MsgManagmentForm = new MessageManagmentForm();
            MsgManagmentForm.MoveEx("center", 0, 0);
            MsgManagmentForm.OnClosed.Attach(
            function()
            {
                MsgManagmentForm = null;
            });
        }
        MsgManagmentForm.Show(true);
        MsgManagmentForm.Open(user);
    }
    
    var m_CreateGroupForm = null;
    
    this.ShowCreateGroupForm = function()
    {
        if (m_CreateGroupForm == null)
        {
            m_CreateGroupForm = new CreateGroupForm();
            m_CreateGroupForm.MoveEx("center", 0, 0);
            m_CreateGroupForm.OnClosed.Attach(
            function()
            {
                m_CreateGroupForm = null;
            });
        }
        m_CreateGroupForm.Show(true);
        return m_CreateGroupForm;
    }
    
    var m_ShareBrowserForm = null;
    
    this.OpenShareBrowser = function(name)
    {
        if (m_CreateGroupForm == null)
        {
            m_ShareBrowserForm = new GroupShareForm();
            m_ShareBrowserForm.MoveEx("center", 0, 0);
            m_ShareBrowserForm.OnClosed.Attach(
            function()
            {
                m_ShareBrowserForm = null;
            });
        }
        m_ShareBrowserForm.Show(true);
        m_ShareBrowserForm.SetCurrentPath(System.GetFullPath("Share/" + name));
        return m_ShareBrowserForm;
    }
    
    this.Exit = function()
    {
        if (MsgManagmentForm != null) MsgManagmentForm.Close();
        MsgManagmentForm = null;
    
        if (m_ShareBrowserForm != null) m_ShareBrowserForm.Close();
        m_ShareBrowserForm = null;
    
        if (m_AddFriendForm != null) m_AddFriendForm.Close();
        m_AddFriendForm = null;
    
        MessageCache.Stop();
        MessageCache = null;
    
        ChatFormManager.Dispose();
        CurrentApplication.Dispose();
    }    

    this.Start = function(baseUrl)
    {
        //应用程序入口;
        if (Instance == null)
        {
            Instance = CurrentApplication;
        
            ChatFormManager.Initialize();
        
            MessageCache = new MessageCacheCtor();
            MessageCache.Start();
        
            m_MainForm = new MainForm();
        
            m_MainForm.MoveEx("Right|Top", -20, 10);
        
            if (arguments[2] == undefined || !arguments[2])
            {
                m_MainForm.Show(true);
            }
        
            m_MainForm.OnClosed.Attach(
            function()
            {
                Instance.Exit();
                Instance = null;
            });
        }
        else
        {
            Instance.ShowMainForm();
        }
        
        if (arguments[1] != undefined)
        {
            if (typeof arguments[1] == "string")
            {
                Instance.StartChatWith(arguments[1]);
            }
            else if (typeof arguments[1] == "object")
            {
                if (arguments[1].Command == "AddFriend")
                {
                    if (arguments[1].ID != System.GetUserInfo().ID)
                    {
                        var form = ShowAddFriendForm();
                        form.SetInfo(0, arguments[1].Name, "");
                    }
                }
            }
        }
    }

    this.Terminate = function(completeCallback, errorCallback)
    {
        try
        {
            //应用程序终止，退出系统时用系统调用;
            completeCallback();
        }
        catch (ex)
        {
            errorCallback(new Exception(ex.mame, ex.message));
        }
    }
    function MainForm()
    {
        var This = this;
        var OwnerForm = this;
        
        var config = {"Left":41,"Top":11,"Width":250,"Height":630,"AnchorStyle":Controls.AnchorStyle.Right|Controls.AnchorStyle.Top,"Parent":null,"Css":"window","BorderWidth":6,"HasMinButton":true,"HasMaxButton":true,"Resizable":true,"Title":{"InnerHTML":"即时通讯"}};
        config.MinWidth = 250;
    
        Window.call(This, config);
    
        var Base = {
            GetType: This.GetType,
            is: This.is
        };
    
        This.GetType = function() { return "MainForm"; }
        This.is = function(type) { return type == This.GetType() ? true : Base.is(type); }
        
        var client = new Controls.Control({"Left":1,"Top":1,"Width":235,"Height":598,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top|Controls.AnchorStyle.Bottom,"Parent":This,"Text":"","Css":"control"});
        
        
        
        client.OnResized.Attach(
            function(btn)
            {
                
            }
        )

        
        var toolbar3 = new Controls.Toolbar({"Left":0,"Top":0,"Width":236,"Height":24,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":client,"Text":"","Css":"toolbar","Items":[{"Text":"添加好友/群","Css":"Image22_Add","Command":"AddFriend"},{"Text":"新建群","Css":"Image22_Add","Command":"CreateGroup"}]});
        
        
        
        toolbar3.OnCommand.Attach(
            function(command)
            {
                if (command == "AddFriend")
                {
                   ShowAddFriendForm();
                }
                else if (command == "CreateGroup")
                {
                    CurrentApplication.ShowCreateGroupForm();
                }
            }
        )

        
        var m_FriendPanel_Config={"Left":0,"Top":26,"Width":235,"Height":571,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top|Controls.AnchorStyle.Bottom,"Parent":client,"Text":"","Css":"friendPanel"};
        
                m_FriendPanel_Config.BorderWidth=1;
                
        
        var m_FriendPanel = new FriendPanel(m_FriendPanel_Config);
        
        
        m_FriendPanel.OnDblClick.Attach(
        function(node)
        {
            var tag = node.GetTag();
            This.ChatWith(tag.Name);
        });
    
    
        var m_Task = null;
        if(config.HasMinButton)
        {
            m_Task=Taskbar.AddTask(This,IsNull(config.Title.InnerHTML,""));
            This.OnClosed.Attach(
                function()
                {
                    Taskbar.RemoveTask(m_Task);
                }
            );
        }
        This.ChatWith = function(name)
        {
            if (name.toUpperCase() != System.GetUser().toUpperCase())
            {
                var form = ChatFormManager.CreateChatForm(name);
                form.Show(true);
            }
        }
    }

}

var FriendPanelDataSource = {};
FriendPanelDataSource.GetSubNodes = function(callback, node)
{
    if (node == null)
    {
        var nodes = [{
            Name: "Users",
            Text: "联系人",
            Tag: null,
            ImageCss: "Image16_Folder"
        },
        {
            Name: "Groups",
            Text: "群",
            Tag: null,
            ImageCss: "Image16_Folder"
        }];
        callback(nodes);
    }
    else
    {
        var name = node.GetName();
        if (name != "Users" && name != "Groups") return null;

        var type = (name == "Users" ? 0 : 1);
        var friends = FriendManager.GetAllFriends();
        var nodes = [];
        for (var k in friends)
        {
            var friend = friends[k];
            if (friend.Type == type)
            {
                nodes.push({
                    Name: friend.Name,
                    Text: friend.Nickname,
                    Tag: friend,
                    HasChildren: false,
                    ImageCss: type == 1 ? "Image16_Group": "Image16_User"
                });
            }
        }
        callback(nodes);
    }
}

function FriendPanel(config)
{
    var This = this;
    var OwnerForm = this;
    
config.DataSource = FriendPanelDataSource;
    
    var width = config.Width, height = config.Height;
    config.Width=200;
    config.Height=200;

    Controls.TreeView.call(This, config);

    var Base = {
        GetType: This.GetType,
        is: This.is
    };

    This.GetType = function() { return "FriendPanel"; }
    This.is = function(type) { return type == This.GetType() ? true : Base.is(type); }
    

    var m_UserMenuConfig = {
        Items: [{
            Text: "删除好友",
            ID: "DeleteFriend"
        }]
    };
    
    var m_GroupMenuConfig = {
        Items: [{
            Text: "退出该群",
            ID: "ExitGroup"
        },
        {
            Text: "查看群组资料",
            ID: "ViewGroupInfo"
        }]
    };
    
    var m_GroupManagementMenuConfig = {
        Items: [{
            Text: "解散该群",
            ID: "DeleteGroup"
        },
        {
            Text: "查看群组资料",
            ID: "ViewGroupInfo"
        }]
    };
    
    function OnCommand(cmd)
    {
        var node = This.GetSelectedNode();
        if (node == null) return;
        var tag = node.GetTag();
        if (tag == null) return;
    
        if (cmd == "DeleteFriend")
        {
            CommonDialog.Confirm(
            String.format('您确定要删除好友:{0}?', tag.Name), null,
            function()
            {
                Management.Management.DeleteFriend(
                function()
                {},
                function(error)
                {
                    CommonDialog.Alert(error.Message, null);
                },
                tag.Name);
            });
        }
        else if (cmd == "DeleteGroup")
        {
            CommonDialog.Confirm(
            String.format('您确定要解散群:{0}?', tag.Name), null,
            function()
            {
                Management.Management.DeleteGroup(
                function()
                {},
                function(error)
                {
                    CommonDialog.Alert(error.Message, null);
                },
                tag.Name);
            });
        }
        else if (cmd == "ExitGroup")
        {
            CommonDialog.Confirm(
            String.format('您确定要退出群:{0}?', tag.Name), null,
            function()
            {
                Management.Management.DeleteFriend(
                function()
                {},
                function(error)
                {
                    CommonDialog.Alert(error.Message, null);
                },
                tag.Name);
            });
        }
        else if (cmd == "ViewGroupInfo")
        {
            var form = new GroupManageForm(tag.Name);
            form.MoveEx("center", 0, 0);
            form.Show(true);
        }
    }
    
    var m_UserMenu = new Controls.Menu(m_UserMenuConfig);
    var m_GroupMenu = new Controls.Menu(m_GroupMenuConfig);
    var m_GroupManagementMenu = new Controls.Menu(m_GroupManagementMenuConfig);
    
    m_UserMenu.OnCommand.Attach(OnCommand);
    m_GroupMenu.OnCommand.Attach(OnCommand);
    m_GroupManagementMenu.OnCommand.Attach(OnCommand);
    
    This.GetContextMenu = function()
    {
        var node = This.GetSelectedNode();
        if (node == null) return null;
        var tag = node.GetTag();
        if (tag == null) return null;
    
        if (tag.Type == 0)
        {
            return m_UserMenu;
        }
        else if (tag.Type == 1)
        {
            if (tag.Creator.toUpperCase() == System.GetUser().toUpperCase()) return m_GroupManagementMenu;
            else return m_GroupMenu;
        }
    }
    
    function OnChanged(data)
    {
        This.Refresh(
        function()
        {
            This.Expand(
            function(node, error)
            {},
            "/Users");
    
            This.Expand(function()
            {},
            "/Groups");
            //ChatFormManager.CloseInvalidForms();
        });
    }
    
    FriendManager.OnChanged.Attach(OnChanged);
    
    This.Load(function()
    {
        This.Expand(function(node, error)
        {},
        "/Users");
        This.Expand(function(node, error)
        {},
        "/Groups");
    });

    This.Resize(width,height);
}

function UserChatForm()
{
    var This = this;
    var OwnerForm = this;
    
    var config = {"Left":1,"Top":1,"Width":680,"Height":680,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":null,"Css":"window","BorderWidth":6,"HasMinButton":true,"HasMaxButton":true,"Resizable":true,"Title":{"InnerHTML":"UserChatForm"}};
    

    Window.call(This, config);

    var Base = {
        GetType: This.GetType,
        is: This.is
    };

    This.GetType = function() { return "UserChatForm"; }
    This.is = function(type) { return type == This.GetType() ? true : Base.is(type); }
    
    var control1 = new Controls.Control({"Left":7,"Top":29,"Width":654,"Height":615,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top|Controls.AnchorStyle.Bottom,"Parent":This,"Text":"","Css":"control"});
    
    
    
    control1.OnResized.Attach(
        function(btn)
        {
            
        }
    )

    
    var m_MessagePanel_Config={"Left":0,"Top":1,"Width":654,"Height":425,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top|Controls.AnchorStyle.Bottom,"Parent":control1,"Text":"","Css":"control"};
    
            m_MessagePanel_Config.BorderWidth = 1;
            m_MessagePanel_Config.Operation = [{
                Text: "引用",
                Command: "Quote"
            }];
    
    var m_MessagePanel = new MessagePanel(m_MessagePanel_Config);
    
    function MessagePanel_OnCommand(cmd,msg,msgHtml)
    {
        if (cmd == "Quote")
        {
            m_MessageEditor.Append(String.format("<div class='message_quote'>" + "<div class='messageTitle'>" + "<span class='sender'>{0}</span>" + "<span class='time'>{1}</span>" + "</div>" + "<div class='messageContent'>{2}</div>" + "</div><br/>", msg.SenderNickname, DateToString(msg.CreatedTime), msg.Content));
        }
    }
    
    m_MessagePanel.OnCommand.Attach(MessagePanel_OnCommand);

    
    var m_BtnSend = new Controls.Button({"Left":520,"Top":589,"Width":134,"Height":26,"AnchorStyle":Controls.AnchorStyle.Right|Controls.AnchorStyle.Bottom,"Parent":control1,"Text":"发送(Ctrl+Enter)","Css":"button_default"});
    
    
    
    m_BtnSend.OnClick.Attach(
        function(btn)
        {
            var content = m_MessageEditor.GetValue();
            m_MessageEditor.SetValue(" ");
            m_MessageEditor.Focus();
            This.SendMessage(null, content);
        }
    )

    
    var m_MessageEditor_Config={"Left":0,"Top":430,"Width":654,"Height":150,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Bottom,"Parent":control1,"Text":"","Css":"control"};
    
            m_MessageEditor_Config.BorderWidth = 1;
    
    var m_MessageEditor = new MessageEditor(m_MessageEditor_Config);
    
    

    
    var m_Toolbar = new Controls.Toolbar({"Left":7,"Top":4,"Width":654,"Height":24,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top,"Parent":This,"Text":"","Css":"toolbar","Items":[{"Text":"发送文件","Css":"Image22_MoveTo","Command":"SendFile"},{"Text":"聊天记录","Css":"Image22_MessageRecord","Command":"ViewRecord"},{"Text":"加为好友","Css":"Image22_Add","Command":"AddFriend"}]});
    
    if (FriendManager.GetFriendInfo(arguments[0].Name) != null) m_Toolbar.SetButtonVisible(2,false);
    
    m_Toolbar.OnCommand.Attach(
        function(command)
        {
            function AddFiles(paths)
            {
                This.SendFiles(function()
                {
                    m_MessageEditor.SetValue("");
                    m_MessageEditor.Focus();
                },
                paths);
            }
            
            if (command == "SendFile")
            {
                CommonDialog.OpenFile({
                    InitPath: "/" + System.GetUser() + "/Home"
                },
                m_Toolbar.GetTopContainer(), AddFiles);
            }
            else if (command == "ViewRecord")
            {
                Instance.OpenMessages(peer.Name);
            }
            else if (command == "AddFriend")
            {
                var form = ShowAddFriendForm();
                form.SetInfo(0, peer.Name, "");
            }
        }
    )
    

    var m_Task = null;
    if(config.HasMinButton)
    {
        m_Task=Taskbar.AddTask(This,IsNull(config.Title.InnerHTML,""));
        This.OnClosed.Attach(
            function()
            {
                Taskbar.RemoveTask(m_Task);
            }
        );
    }
    This.SendMessage = function(callback, content)
    {
        if (content != "" && content != " ")
        {
            var tm_content = TranslateMessage(content);
            var temp = m_MessagePanel.CreateMessage(tm_content);
            try
            {
                Communication.Communication.SendInstantMessage(
                function(msg)
                {
                    m_MessagePanel.AddMessage(msg, temp);
                    if (callback != null) callback(null);
                },
                function(error)
                {
                    m_MessagePanel.ShowError(error.Message, temp);
                    if (callback != null) callback(error);
                },
                peer.Name, tm_content, []);
            }
            catch(ex)
            {
                m_MessagePanel.ShowError(ex.message, temp);
            }
        }
    }
    
    This.Notify = function()
    {
        if (!This.IsVisible() || !This.IsTop())
        {
            if (m_Task != null) m_Task.Shine(true);
        }
    }
    
    This.SendFiles = function(callback, paths)
    {
        if (paths.length > 0)
        {
            var content = m_MessageEditor.CreateFileHtml(paths);
            This.SendMessage(callback, content);
        }
    }
    
    m_MessageEditor.OnKeyDown.Attach(
    function(evt)
    {
        if (evt.keyCode == 13 && evt.ctrlKey && !evt.shiftKey && !evt.altKey)
        {
            var content = m_MessageEditor.GetValue();
            m_MessageEditor.SetValue(" ");
            m_MessageEditor.Focus();
            This.SendMessage(null, content);
        }
    });
    
    Controls.CreateHorizSplit(m_MessagePanel, m_MessageEditor, false);
    
    var peer = arguments[0];
    
    This.GetReceiver = function()
    {
        return peer;
    }
    
    This.AddMessage = function(msg)
    {
        m_MessagePanel.AddMessage(msg);
    }
    
    System.AttachEvent(
    m_MessageEditor.GetDocument(), "mousedown",
    function()
    {
        This.Show(true);
    });
    
    System.AttachEvent(
    m_MessagePanel.GetDocument(), "mousedown",
    function()
    {
        This.Show(true);
    });
    
    This.SetTitle(String.format("和 {0} 交谈", This.GetReceiver().Nickname));
    m_Task.SetText(This.GetReceiver().Nickname);
}




function MessagePanel(config)
{
    var This = this;
    var OwnerForm = this;
    
config.Css = "messageContainer";
    
    var width = config.Width, height = config.Height;
    config.Width=200;
    config.Height=200;

    Controls.Frame.call(This, config);

    var Base = {
        GetType: This.GetType,
        is: This.is
    };

    This.GetType = function() { return "MessagePanel"; }
    This.is = function(type) { return type == This.GetType() ? true : Base.is(type); }
    

    var m_FileHtmlFormat = "<div class='div_filename'>文件名:{0}</div>" + "<div class='operationContainer'>" + "<div class='link_download'><a target='_blank' href='download.aspx?FileName={1}'>下载</a></div>" + "<div class='link_saveas'><span onclick='javascript:window.SaveFile(unescape(\"{1}\"))'>另存为</span></div>" + "<div class='link_open'><span onclick='javascript:window.OpenFile(unescape(\"{1}\"))'>打开</span></div>" + "</div>";
    
    This.OnCommand = new Delegate();
    
    This.Clear = function()
    {
        This.GetDocument().body.innerHTML = "";
    }
    
    This.CreateMessage = function(content)
    {
        content = content.replace(/<img\s[^<>]*>/ig,
        function(val)
        {
            return String.format("<img src='{0}'/>", Module.GetResourceUrl("loading_img.gif"));
        });
    
        content = content.replace(/\x5BFILE\x3A\s*\{Accessory\s+type=\"file\"\s+src=\"([^\t\n\r\f\v\x5B\x5D]+)\"\}\x5D/ig,
        function(val, file)
        {
            return String.format("<div class='div_filename'><img src='{0}'/></div>", Module.GetResourceUrl("loading_file.gif"), file);
        });
    
        var msgDiv = This.GetDocument().createElement("DIV");
        msgDiv.className = "message";
        msgDiv.innerHTML = String.format("<div class='messageTitle'>" + "<span class='sender'>{0}</span>" + "<span class='time'>{1}</span>" + "<div class='operationContainer' style='display:none;'>" + "</div>" + "</div>" + "<div class='messageContent'>{2}" + "</div>", Me.Nickname, DateToString(new Date()), content);
        This.GetDocument().body.appendChild(msgDiv);
        msgDiv.scrollIntoView();
        return msgDiv;
    }
    
    This.ShowError = function(msg, temp)
    {
        temp.childNodes[1].innerHTML =String.format("<span style='color:Red; '>{0}</span>", System.ReplaceHtml(msg));
    }
    
    This.AddMessage = function(msg, temp)
    {
        msg.Content = msg.Content.replace(/\x5BFILE\x3A[^\t\n\r\f\v\x5B\x5D]+\x5D/ig,
        function(val)
        {
            var file = val.substr(6, val.length - 7);
            return String.format(
            m_FileHtmlFormat, System.Path.GetFileName(unescape(file)), file);
        });
    
        msg.Content = msg.Content.replace(/\x5BA\x3A[^\t\n\r\f\v\x5B\x5D]+\x5D/ig,
        function(val)
        {
            var file = val.substr(3, val.length - 4);
            return String.format("<a target='_blank' href='{0}' onclick='return window.OpenLink(this.href);'>", unescape(file));
        });
    
        msg.Content = msg.Content.replace(/\x5B\x2FA\x5D/ig,
        function(val)
        {
            return "</a>";
        });
    
        var msgDiv = This.GetDocument().createElement("DIV");
        msgDiv.className = "message";
        msgDiv.innerHTML = String.format("<div class='messageTitle'>" + "<span class='sender'>{0}</span>" + "<span class='time'>{1}</span>" + "<div class='operationContainer' style='display:none;'>" + "</div>" + "</div>" + "<div class='messageContent'>{2}" + "</div>", msg.SenderNickname, DateToString(msg.CreatedTime), msg.Content);
        msgDiv.onmousemove = function()
        {
            this.firstChild.childNodes[2].style.display = "inline";
        }
        msgDiv.onmouseout = function()
        {
            this.firstChild.childNodes[2].style.display = "none";
        }
    
        if (config.Operation != undefined)
        {
            for (var i in config.Operation)
            {
                try
                {
                    var ope = config.Operation[i];
                    (function(text, cmd, msg, msgHtml, callback)
                    {
                        var opeLink = This.GetDocument().createElement("A");
                        opeLink.className = "operation";
                        opeLink.innerHTML = text;
                        opeLink.onclick = function()
                        {
                            callback(cmd, msg, msgHtml);
                        }
                        var opeContainer = msgDiv.firstChild.childNodes[2];
                        opeContainer.appendChild(opeLink);
                    })(ope.Text, ope.Command, msg, msgDiv.innerHTML,
                    function(cmd, msg, msgHtml)
                    {
                        This.OnCommand.Call(cmd, msg, msgHtml);
                    });
                }
                catch(ex)
                {}
            }
        }
        if (temp == undefined)
        {
            This.GetDocument().body.appendChild(msgDiv);
        }
        else
        {
            This.GetDocument().body.replaceChild(msgDiv, temp);
        }
        msgDiv.scrollIntoView();
        msgDiv = null;
    }
    
    This.Link("StyleSheet", Module.GetResourceUrl("EditorCss.css"), "text/css");
    
    This.GetWindow().OpenLink = function(href)
    {
        return confirm(String.format("您确定要打开链接 \"{0}\"", href));;
    }
    
    This.GetWindow().SaveFile = function(filePath)
    {
        var folderBrowser = new CommonDialog.FolderBrowserDialog({
            Left: 0,
            Top: 0,
            Width: 400,
            Height: 400,
            Css: 'window',
            BorderWidth: 6,
            Resizable: true,
            HasMinButton: false,
            Title: {
                Height: 18,
                InnerHTML: '另存为'
            },
            Desription: "请选择文件夹:",
            Root: System.GetFullPath("Home")
        });
        folderBrowser.OnSelected.Attach(
        function(fb)
        {
            var path = fb.GetSelectedFolderPath();
            if (path != null)
            {
                This.GetTopContainer().Waiting("正在保存文件...");
    
                IO.File.Copy(
                function()
                {
                    This.GetTopContainer().Completed();
                },
                function(error)
                {
                    This.GetTopContainer().Completed();
                    CommonDialog.Alert(error.Message, This.GetTopContainer());
                },
                [filePath], path);
            }
        });
        folderBrowser.ShowDialog(This.GetTopContainer(), 'center', 0, 0);
        folderBrowser.Focus();
    }
    
    This.GetWindow().OpenFile = function(filePath)
    {
        System.Exec(function()
        {},
        alert, "OpenWith.js", filePath, false);
    }

    This.Resize(width,height);
}




function MessageEditor(config)
{
    var This = this;
    var OwnerForm = this;
    
config.StyleSheet = Module.GetResourceUrl("EditorCss.css");
    
    var width = config.Width, height = config.Height;
    config.Width=200;
    config.Height=200;

    RichEditor.call(This, config);

    var Base = {
        GetType: This.GetType,
        is: This.is
    };

    This.GetType = function() { return "MessageEditor"; }
    This.is = function(type) { return type == This.GetType() ? true : Base.is(type); }
    

    This.CreateFileHtml = function(paths)
    {
        var fs = [];
        for (var i in paths)
        {
            var html = "<div contenteditable='false' class='message_file'>" + String.format("[FILE:{0}]", paths[i]) + "</div>";
            fs.push(html);
        }
        return "<br/>" + fs.join("<br/>") + "<br/>";
    }

    This.Resize(width,height);
}

function MessageManagmentForm()
{
    var This = this;
    var OwnerForm = this;
    
    var config = {"Left":20,"Top":20,"Width":829,"Height":668,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":null,"Css":"window","BorderWidth":6,"HasMinButton":true,"HasMaxButton":true,"Resizable":true,"Title":{"InnerHTML":"消息管理"}};
    

    Window.call(This, config);

    var Base = {
        GetType: This.GetType,
        is: This.is
    };

    This.GetType = function() { return "MessageManagmentForm"; }
    This.is = function(type) { return type == This.GetType() ? true : Base.is(type); }
    
    var m_Toolbar = new Controls.Toolbar({"Left":1,"Top":1,"Width":815,"Height":24,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top,"Parent":This,"Text":"","Css":"toolbar","Items":[{"Text":"上一页","Css":"Image22_UpButton","Command":"Previous"},{"Text":"下一页","Css":"Image22_DownButton","Command":"Next"}]});
    
    
    
    m_Toolbar.OnCommand.Attach(
        function(command)
        {
            switch (command)
            {
            case "Previous":
                {
                    Load(Current, null, UserPageInfo[Current.ID] == undefined ? null: UserPageInfo[Current.ID].Min);
                    break;
                }
            case "Next":
                {
                    Load(Current, UserPageInfo[Current.ID] == undefined ? null: UserPageInfo[Current.ID].Max, null);
                    break;
                }
            }
        }
    )

    
    var control2 = new Controls.Control({"Left":1,"Top":27,"Width":815,"Height":610,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top|Controls.AnchorStyle.Bottom,"Parent":This,"Text":"","Css":"control"});
    
    
    
    control2.OnResized.Attach(
        function(btn)
        {
            
        }
    )

    
    var m_MessagePanel_Config={"Left":250,"Top":0,"Width":565,"Height":610,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top|Controls.AnchorStyle.Bottom,"Parent":control2,"Text":"","Css":"control"};
    
            m_MessagePanel_Config.BorderWidth = 1;
    
    var m_MessagePanel = new MessagePanel(m_MessagePanel_Config);
    
    

    
    var m_MsgUserTree_Config={"Left":0,"Top":0,"Width":243,"Height":610,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top|Controls.AnchorStyle.Bottom,"Parent":control2,"Text":"","Css":"control"};
    
            m_MsgUserTree_Config.BorderWidth = 1;
    
    var m_MsgUserTree = new MsgUserTree(m_MsgUserTree_Config);
    
    function MsgUserTree_OnClick(node)
    {
        var info = node.GetTag();
        Load(info);
    }
    
    m_MsgUserTree.OnClick.Attach(MsgUserTree_OnClick);
    
    m_MsgUserTree.OnBeginRequest.Attach(function()
    {
        This.Waiting();
    });
    
    m_MsgUserTree.OnEndRequest.Attach(function()
    {
        This.Completed();
    });
    

    var m_Task = null;
    if(config.HasMinButton)
    {
        m_Task=Taskbar.AddTask(This,IsNull(config.Title.InnerHTML,""));
        This.OnClosed.Attach(
            function()
            {
                Taskbar.RemoveTask(m_Task);
            }
        );
    }
    Controls.CreateVerticalSplit(m_MsgUserTree, m_MessagePanel, true);
    
    var UserPageInfo = {};
    var Current;
    
    This.Open = function(user)
    {
        var path = "";
        var info = FriendManager.GetFriendInfo(user);
    
        if (info == null)
        {
            path = String.format("/Strangers/{0}", user);
        }
        else
        {
            path = String.format("/{0}/{1}", info.Type == 0 ? "Users": "Groups", info.Name);
        }
    
        m_MsgUserTree.Select(
        function(node)
        {
            Load(node.GetTag(), null, null);
        },
        path);
    
    }
    
    function Load(info, from, to)
    {
        This.Waiting("正在读取消息...");
        try
        {
            Communication.Communication.FindInstantMessages(
            function(ret)
            {
                ret.Messages.sort(
                function(item1, item2)
                {
                    if (item1.CreatedTime > item2.CreatedTime) return 1;
                    if (item1.CreatedTime < item2.CreatedTime) return - 1;
                    return 0;
                });
                m_MessagePanel.Clear();
                for (var i in ret.Messages)
                {
                    m_MessagePanel.AddMessage(ret.Messages[i]);
                }
                if (ret.Messages.length > 0)
                {
                    UserPageInfo[info.ID] = {
                        Max: ret.Messages[ret.Messages.length - 1].CreatedTime,
                        Min: ret.Messages[0].CreatedTime
                    }
                }
                Current = info;
                This.Completed();
            },
            function(error)
            {
                This.Completed();
                CommonDialog.Alert(error.Message, This);
            },
            info.Type == 0 ? System.GetUser() : info.Name, info.Type == 0 ? info.Name: null, from, to, 50);
        }
        catch(ex)
        {
            This.Completed();
            CommonDialog.Alert(error.Message, This);
        }
    }
}

function GroupChatForm()
{
    var This = this;
    var OwnerForm = this;
    
    var config = {"Left":7,"Top":5,"Width":680,"Height":680,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":null,"Css":"window","BorderWidth":6,"HasMinButton":true,"HasMaxButton":true,"Resizable":true,"Title":{"InnerHTML":"GroupChatForm"}};
    

    Window.call(This, config);

    var Base = {
        GetType: This.GetType,
        is: This.is
    };

    This.GetType = function() { return "GroupChatForm"; }
    This.is = function(type) { return type == This.GetType() ? true : Base.is(type); }
    
    var m_Toolbar = new Controls.Toolbar({"Left":7,"Top":4,"Width":653,"Height":23,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top,"Parent":This,"Text":"","Css":"toolbar","Items":[{"Text":"发送文件","Css":"Image22_MoveTo","Command":"SendFile"},{"Text":"消息记录","Css":"Image22_MessageRecord","Command":"ViewRecord"},{"Text":"群共享","Css":"Image22_Share","Command":"Share"},{"Text":"查看群组资料","Css":"Image22_Option","Command":"ViewGroupInfo"},{"Text":"查看群组成员","Css":"Image22_Option","Command":"ViewGroupMember"}]});
    
    
    
    m_Toolbar.OnCommand.Attach(
        function(command)
        {
            function AddFiles(paths)
            {
                This.SendFiles(function()
                {
                    m_MessageEditor.SetValue("");
                    m_MessageEditor.Focus();
                },
                paths);
            }
            
            if (command == "SendFile")
            {
                CommonDialog.OpenFile({
                    InitPath: "/" + System.GetUser() + "/Home"
                },
                m_Toolbar.GetTopContainer(), AddFiles);
            }
            else if (command == "ViewRecord")
            {
                Instance.OpenMessages(peer.Name);
            }
            else if (command == "Share")
            {
                Instance.OpenShareBrowser(peer.Name);
            }
            else if (command == "ViewGroupInfo")
            {
                var form = new GroupManageForm(peer.Name);
                form.MoveEx("center", 0, 0);
                form.Show(true);
            }
            else if (command == "ViewGroupMember")
            {
                var form = new GroupManageForm(peer.Name);
                form.SelectTab(1);
                form.MoveEx("center", 0, 0);
                form.Show(true);
            }
        }
    )

    
    var control2 = new Controls.Control({"Left":7,"Top":29,"Width":653,"Height":615,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top|Controls.AnchorStyle.Bottom,"Parent":This,"Text":"","Css":"control"});
    
    
    
    control2.OnResized.Attach(
        function(btn)
        {
            
        }
    )

    
    var m_MessagePanel_Config={"Left":0,"Top":1,"Width":653,"Height":425,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top|Controls.AnchorStyle.Bottom,"Parent":control2,"Text":"","Css":"control"};
    
            m_MessagePanel_Config.BorderWidth = 1;
            m_MessagePanel_Config.Operation = [{
                Text: "加为好友",
                Command: "Add"
            },
            {
                Text: "移出本群",
                Command: "Delete"
            },
            {
                Text: "引用",
                Command: "Quote"
            }];
    
    var m_MessagePanel = new MessagePanel(m_MessagePanel_Config);
    
    function MessagePanel_OnCommand(cmd, msg, msgHtml)
    {
        if (cmd == "Quote")
        {
            m_MessageEditor.Append(String.format("<div class='message_quote'>" + "<div class='messageTitle'>" + "<span class='sender'>{0}</span>" + "<span class='time'>{1}</span>" + "</div>" + "<div class='messageContent'>{2}</div>" + "</div><br/>", msg.SenderNickname, DateToString(msg.CreatedTime), msg.Content));
        }
        else if (cmd == "Add")
        {
            var form =ShowAddFriendForm();
            form.SetInfo(0, msg.Sender, String.format("你好！我是来自群 \"{0}\" 的用户，想添加您为好友。",peer.Nickname));
        }
        else if (cmd == "Delete")
        {
            CommonDialog.Confirm(
            String.format('您确定要将"{0}"从本群移除?', msg.Sender), This,
            function()
            {
                This.Waiting();
                Management.Management.RemoveFromGroup(
                function()
                {
                    This.Completed();
                },
                function(error)
                {
                    This.Completed();
                    CommonDialog.Alert(error.Message, This);
                },
                msg.Sender, peer.Name);
            });
        }
    }
    
    m_MessagePanel.OnCommand.Attach(MessagePanel_OnCommand);

    
    var m_MessageEditor_Config={"Left":0,"Top":430,"Width":653,"Height":150,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Bottom,"Parent":control2,"Text":"","Css":"control"};
    
            m_MessageEditor_Config.BorderWidth = 1;
    
    var m_MessageEditor = new MessageEditor(m_MessageEditor_Config);
    
    

    
    var m_BtnSend = new Controls.Button({"Left":527,"Top":589,"Width":126,"Height":26,"AnchorStyle":Controls.AnchorStyle.Right|Controls.AnchorStyle.Bottom,"Parent":control2,"Text":"发送(Ctrl+Enter)","Css":"button_default"});
    
    
    
    m_BtnSend.OnClick.Attach(
        function(btn)
        {
            var content = m_MessageEditor.GetValue();
            m_MessageEditor.SetValue(" ");
            m_MessageEditor.Focus();
            This.SendMessage(null, content);
        }
    )
    

    var m_Task = null;
    if(config.HasMinButton)
    {
        m_Task=Taskbar.AddTask(This,IsNull(config.Title.InnerHTML,""));
        This.OnClosed.Attach(
            function()
            {
                Taskbar.RemoveTask(m_Task);
            }
        );
    }
    This.SendMessage = function(callback, content)
    {
        if (content != "" && content != " ")
        {
            var tm_content = TranslateMessage(content);
            var temp = m_MessagePanel.CreateMessage(tm_content);
            try
            {
                Communication.Communication.SendInstantMessage(
                function(msg)
                {
                    m_MessagePanel.AddMessage(msg, temp);
                    if (callback != null) callback(null);
                },
                function(error)
                {
                    m_MessagePanel.ShowError(error.Message, temp);
                    if (callback != null) callback(error);
                },
                peer.Name, tm_content, []);
            }
            catch(ex)
            {
                m_MessagePanel.ShowError(ex.message, temp);
            }
        }
    }
    
    This.Notify = function()
    {
        if (!This.IsVisible() || !This.IsTop())
        {
            if (m_Task != null) m_Task.Shine(true);
        }
    }
    
    This.SendFiles = function(callback, paths)
    {
        if (paths.length > 0)
        {
            var content = m_MessageEditor.CreateFileHtml(paths);
            This.SendMessage(callback, content);
        }
    }
    
    m_MessageEditor.OnKeyDown.Attach(
    function(evt)
    {
        if (evt.keyCode == 13 && evt.ctrlKey && !evt.shiftKey && !evt.altKey)
        {
            var content = m_MessageEditor.GetValue();
            m_MessageEditor.SetValue(" ");
            m_MessageEditor.Focus();
            This.SendMessage(null, content);
        }
    });
    
    Controls.CreateHorizSplit(m_MessagePanel, m_MessageEditor, false);
    
    var peer = arguments[0];
    
    This.GetReceiver = function()
    {
        return peer;
    }
    
    This.AddMessage = function(msg)
    {
        m_MessagePanel.AddMessage(msg);
    }
    
    System.AttachEvent(
    m_MessageEditor.GetDocument(), "mousedown",
    function()
    {
        This.Show(true);
    });
    
    System.AttachEvent(
    m_MessagePanel.GetDocument(), "mousedown",
    function()
    {
        This.Show(true);
    });
    
    This.SetTitle(String.format("{0}({1})", This.GetReceiver().Nickname, This.GetReceiver().Name));
    m_Task.SetText(This.GetReceiver().Nickname);
}

function AddFriendForm()
{
    var This = this;
    var OwnerForm = this;
    
    var config = {"Left":8,"Top":5,"Width":396,"Height":300,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":null,"Css":"window","BorderWidth":6,"HasMinButton":false,"HasMaxButton":false,"Resizable":false,"Title":{"InnerHTML":"添加好友/群"}};
    

    Window.call(This, config);

    var Base = {
        GetType: This.GetType,
        is: This.is
    };

    This.GetType = function() { return "AddFriendForm"; }
    This.is = function(type) { return type == This.GetType() ? true : Base.is(type); }
    
    var tab1 = new Controls.SimpleTabControl({"Left":1,"Top":1,"Width":382,"Height":268,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top|Controls.AnchorStyle.Bottom,"Parent":This,"Text":"","Css":"simple_tab","Tabs":[{"Text":"好友","Width":80,"ID":"ID000071","IsSelected":true},{"Text":"群","Width":80,"ID":"ID000072","IsSelected":false},{"Text":"邀请","Width":100,"ID":"ID000073","IsSelected":false}],"BorderWidth":1});
    
    
    
    tab1.OnSelectedTab.Attach(
        function(index,preIndex)
        {
            if (index == 2 && m_InviteCode.GetText() == "")
            {
                LoadAnonymusChatCode();
                LoadInviteCode();
            }
        }
    )

    
    var label2 = new Controls.Label({"Left":14,"Top":14,"Width":353,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(0),"Text":"请输入要添加的好友名称：","Css":"label"});
    
    

    
    var m_UserName = new Controls.TextBox({"Left":14,"Top":32,"Width":353,"Height":22,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(0),"Text":"","Css":"textbox","BorderWidth":1});
    
    

    
    var label4 = new Controls.Label({"Left":14,"Top":63,"Width":353,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(0),"Text":"请输入验证信息：","Css":"label"});
    
    

    
    var m_UserVerifyInfo = new Controls.TextArea({"Left":14,"Top":82,"Width":353,"Height":121,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top|Controls.AnchorStyle.Bottom,"Parent":tab1.GetPanel(0),"Text":"","Css":"textarea","BorderWidth":1});
    
    

    
    var m_BtnAddUser = new Controls.Button({"Left":303,"Top":210,"Width":64,"Height":26,"AnchorStyle":Controls.AnchorStyle.Right|Controls.AnchorStyle.Bottom,"Parent":tab1.GetPanel(0),"Text":"确定","Css":"button_default"});
    
    
    
    m_BtnAddUser.OnClick.Attach(
        function(btn)
        {
            if (m_UserName.GetText() == "")
            {
                CommonDialog.Alert("请输入用户帐号！", This);
                return;
            }
            
            This.Waiting();
            Management.Management.SendAddFriendRequest(
            function()
            {
                This.Completed();
                m_UserName.SetText("");
                m_UserVerifyInfo.SetText("");
                CommonDialog.Alert("你的好友添加请求已发送成功，等待对方验证...", This);
            },
            function(error)
            {
                This.Completed();
                CommonDialog.Alert(error.Message, This);
            },
            m_UserName.GetText(), m_UserVerifyInfo.GetText());
        }
    )

    
    var label8 = new Controls.Label({"Left":14,"Top":14,"Width":353,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(1),"Text":"请输入要进入的群的名称：","Css":"label"});
    
    

    
    var m_GroupName = new Controls.TextBox({"Left":14,"Top":32,"Width":353,"Height":22,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(1),"Text":"","Css":"textbox","BorderWidth":1});
    
    

    
    var label10 = new Controls.Label({"Left":14,"Top":63,"Width":353,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(1),"Text":"请输入验证信息：","Css":"label"});
    
    

    
    var m_GroupVerifyInfo = new Controls.TextArea({"Left":14,"Top":82,"Width":353,"Height":121,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top|Controls.AnchorStyle.Bottom,"Parent":tab1.GetPanel(1),"Text":"","Css":"textarea","BorderWidth":1});
    
    

    
    var m_BtnAddGroup = new Controls.Button({"Left":303,"Top":210,"Width":64,"Height":26,"AnchorStyle":Controls.AnchorStyle.Right|Controls.AnchorStyle.Bottom,"Parent":tab1.GetPanel(1),"Text":"确定","Css":"button_default"});
    
    
    
    m_BtnAddGroup.OnClick.Attach(
        function(btn)
        {
            if (m_GroupName.GetText() == "")
            {
                CommonDialog.Alert("请输入群帐号！", This);
                return;
            }
            
            This.Waiting();
            Management.Management.SendAddFriendRequest(
            function()
            {
                This.Completed();
                m_GroupName.SetText("");
                m_GroupVerifyInfo.SetText("");
                CommonDialog.Alert("你的群添加请求已发送成功，等待对方验证...", This);
            },
            function(error)
            {
                This.Completed();
                CommonDialog.Alert(error.Message, This);
            },
            m_GroupName.GetText(), m_GroupVerifyInfo.GetText());
        }
    )

    
    var IM_Label_Blue = new Controls.Label({"Left":14,"Top":11,"Width":352,"Height":15,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(2),"Text":"通过以下链接注册（或登录）的用户将同时添加您为好友，并启动","Css":"label"});
    
    

    
    var m_InviteCode = new Controls.TextArea({"Left":14,"Top":52,"Width":352,"Height":45,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(2),"Text":"","Css":"InviteForm_TextArea","BorderWidth":1});
    
    m_InviteCode.GetTextAreaDom().readOnly = true;

    
    var label16 = new Controls.Label({"Left":14,"Top":107,"Width":352,"Height":15,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(2),"Text":"通过以下链接注册（或登录）的用户进入系统时将同时启动与您的","Css":"label"});
    
    

    
    var m_AnonymusChatCode = new Controls.TextArea({"Left":14,"Top":142,"Width":352,"Height":86,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(2),"Text":"","Css":"InviteForm_TextArea","BorderWidth":1});
    
    m_AnonymusChatCode.GetTextAreaDom().readOnly = true;

    
    var label18 = new Controls.Label({"Left":14,"Top":28,"Width":104,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(2),"Text":"与您的会话：","Css":"label"});
    
    

    
    var label19 = new Controls.Label({"Left":14,"Top":124,"Width":111,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(2),"Text":"会话：","Css":"label"});
    
    

    
    var m_UpdateInviteCode = new Controls.Label({"Left":313,"Top":28,"Width":50,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(2),"Text":"更新链接","Css":"IM_Label_Link"});
    
    m_UpdateInviteCode.GetDom().onclick = function()
    {
        CommonDialog.Confirm("更新后您原有的链接将失效，你确定要更新链接吗？", This,
        function()
        {
            This.Waiting("");
            Management.Management.UpdateInviteCode(
            function(code)
            {
                This.Completed();
                m_InviteCode.SetText(String.format("http://{0}{1}/Login.aspx?User={2}&InviteCode={3}", window.location.host, System.Path.GetDirectoryName(window.location.pathname), System.GetUser(), code));
            },
            function(error)
            {
                This.Completed();
                CommonDialog.Alert(error.Message, This);
            });
        });
    }
    

    var m_Task = null;
    if(config.HasMinButton)
    {
        m_Task=Taskbar.AddTask(This,IsNull(config.Title.InnerHTML,""));
        This.OnClosed.Attach(
            function()
            {
                Taskbar.RemoveTask(m_Task);
            }
        );
    }
    function LoadInviteCode()
    {
        This.Waiting("");
        Management.Management.GetUserInfo(
        function(info)
        {
            This.Completed();
            m_InviteCode.SetText(System.MakeInviteUrl(System.GetUser(), info.InviteCode));
            m_AnonymusChatCode.SetText(System.MakeChatUrl(info.Name, info.Nickname));
        },
        function(error)
        {
            This.Completed();
            CommonDialog.Alert(error.Message, This);
        },
        System.GetUser());
    }
    
    function LoadAnonymusChatCode()
    {}
    
    This.SetInfo = function(type, name, verify)
    {
        if (type == 0)
        {
            tab1.Select(type);
            m_UserName.SetText(name);
            m_UserVerifyInfo.SetText(verify);
        }
        else if (type == 1)
        {
            tab1.Select(type);
            m_GroupName.SetText(name);
            m_GroupVerifyInfo.SetText(verify);
        }
    }
}

function CreateGroupForm()
{
    var This = this;
    var OwnerForm = this;
    
    var config = {"Left":16,"Top":29,"Width":366,"Height":276,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":null,"Css":"window","BorderWidth":6,"HasMinButton":false,"HasMaxButton":false,"Resizable":false,"Title":{"InnerHTML":"创建群"}};
    

    Window.call(This, config);

    var Base = {
        GetType: This.GetType,
        is: This.is
    };

    This.GetType = function() { return "CreateGroupForm"; }
    This.is = function(type) { return type == This.GetType() ? true : Base.is(type); }
    
    var label1 = new Controls.Label({"Left":9,"Top":11,"Width":335,"Height":31,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":This,"Text":"请输入群的帐户名(不少于6个字符，只能包含英文字符，数字和下划线)：","Css":"label"});
    
    

    
    var m_EditName = new Controls.TextBox({"Left":9,"Top":46,"Width":335,"Height":22,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":This,"Text":"","Css":"textbox","BorderWidth":1});
    
    

    
    var label3 = new Controls.Label({"Left":9,"Top":75,"Width":335,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":This,"Text":"请输入群的名称：","Css":"label"});
    
    

    
    var m_EditInfo = new Controls.TextArea({"Left":9,"Top":94,"Width":335,"Height":112,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":This,"Text":"","Css":"textarea","BorderWidth":1});
    
    

    
    var m_BtnOK = new Controls.Button({"Left":280,"Top":213,"Width":64,"Height":26,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":This,"Text":"确定","Css":"button_default"});
    
    
    
    m_BtnOK.OnClick.Attach(
        function(btn)
        {
            if (m_EditName.GetText() == "")
            {
                CommonDialog.Alert("请输入群帐号！", This);
                return;
            }
            if (m_EditInfo.GetText() == "")
            {
                CommonDialog.Alert("请输入群名称！", This);
                return;
            }
            This.Waiting();
            Management.Management.CreateGroup(
            function()
            {
                This.Completed();
                This.Close();
            },
            function(error)
            {
                This.Completed();
                CommonDialog.Alert(error.Message, This);
            },
            m_EditName.GetText(), m_EditInfo.GetText());
        }
    )

    
    var label7 = new Controls.Label({"Left":9,"Top":218,"Width":258,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":This,"Text":"注意：群消息及共享文件将存放在您的网盘上！","Css":"IM_Label_Warning"});
    
    
    

    var m_Task = null;
    if(config.HasMinButton)
    {
        m_Task=Taskbar.AddTask(This,IsNull(config.Title.InnerHTML,""));
        This.OnClosed.Attach(
            function()
            {
                Taskbar.RemoveTask(m_Task);
            }
        );
    }
    
}

function GroupShareForm()
{
    var This = this;
    var OwnerForm = this;
    
    var config = {"Left":5,"Top":3,"Width":760,"Height":602,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":null,"Css":"window","BorderWidth":6,"HasMinButton":true,"HasMaxButton":true,"Resizable":true,"Title":{"InnerHTML":"群共享"}};
    

    Window.call(This, config);

    var Base = {
        GetType: This.GetType,
        is: This.is
    };

    This.GetType = function() { return "GroupShareForm"; }
    This.is = function(type) { return type == This.GetType() ? true : Base.is(type); }
    
    var filebrowser1_Config={"Left":1,"Top":1,"Width":746,"Height":570,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top|Controls.AnchorStyle.Bottom,"Parent":This,"Text":"","BorderWidth":0};
    filebrowser1_Config.Root=System.GetFullPath("Share");
    
    filebrowser1_Config.OnBeginRequest=function()
    {
        filebrowser1.GetTopContainer().Waiting();
    }
    
    filebrowser1_Config.OnEndRequest=function()
    {
        filebrowser1.GetTopContainer().Completed();
    }
    
    var filebrowser1 = new CommonDialog.FileBrowser(filebrowser1_Config);
    
    filebrowser1.Expand(
    function()
    {},
    System.GetFullPath("Share"));
    
    filebrowser1.OnFileItemDblClick.Attach(
    function(item)
    {
        System.Exec(function()
        {},
        alert, "OpenWith.js", filebrowser1.GetCurrentPath() + '/' + item.GetFileInfo("Name"), false);
    });
    

    var m_Task = null;
    if(config.HasMinButton)
    {
        m_Task=Taskbar.AddTask(This,IsNull(config.Title.InnerHTML,""));
        This.OnClosed.Attach(
            function()
            {
                Taskbar.RemoveTask(m_Task);
            }
        );
    }
    This.Select = function(path)
    {
        filebrowser1.Select(function()
        {},
        path);
    }
    
    This.SetCurrentPath = function(path)
    {
        filebrowser1.SetCurrentPath(path);
    }
}




function GroupInfoPanel(config)
{
    var This = this;
    var OwnerForm = this;
    

    
    var width = config.Width, height = config.Height;
    config.Width=430;
    config.Height=312;

    Control.call(This, config);

    var Base = {
        GetType: This.GetType,
        is: This.is
    };

    This.GetType = function() { return "GroupInfoPanel"; }
    This.is = function(type) { return type == This.GetType() ? true : Base.is(type); }
    
    var label2 = new Controls.Label({"Left":0,"Top":4,"Width":55,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":This,"Text":"群账户：","Css":"label"});
    
    

    
    var label3 = new Controls.Label({"Left":0,"Top":39,"Width":55,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":This,"Text":"群名称：","Css":"label"});
    
    

    
    var m_EditName = new Controls.TextBox({"Left":60,"Top":0,"Width":369,"Height":22,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top,"Parent":This,"Text":"","Css":"textbox","BorderWidth":1});
    
    m_EditName.GetTextBoxDom().readOnly = true;

    
    var m_EditNickname = new Controls.TextBox({"Left":60,"Top":34,"Width":369,"Height":22,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top,"Parent":This,"Text":"","Css":"textbox","BorderWidth":1});
    
    

    
    var label6 = new Controls.Label({"Left":0,"Top":71,"Width":54,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":This,"Text":"创建者：","Css":"label"});
    
    

    
    var m_EditCreator = new Controls.TextBox({"Left":60,"Top":67,"Width":369,"Height":22,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top,"Parent":This,"Text":"","Css":"textbox","BorderWidth":1});
    
    m_EditCreator.GetTextBoxDom().readOnly = true;

    
    var label8 = new Controls.Label({"Left":1,"Top":103,"Width":63,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":This,"Text":"邀请链接：","Css":"label"});
    
    

    
    var label9 = new Controls.Label({"Left":65,"Top":103,"Width":285,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":This,"Text":"(通过以下链接登录或注册的用户将同时加入本群)","Css":"IM_Label_Blue"});
    
    

    
    var m_EditLink = new Controls.TextArea({"Left":0,"Top":124,"Width":430,"Height":154,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top|Controls.AnchorStyle.Bottom,"Parent":This,"Text":"","Css":"textarea","BorderWidth":1});
    
    m_EditLink.GetTextAreaDom().readOnly = true;

    
    var label11 = new Controls.Label({"Left":376,"Top":103,"Width":53,"Height":14,"AnchorStyle":Controls.AnchorStyle.Right|Controls.AnchorStyle.Top,"Parent":This,"Text":"更新链接","Css":"IM_Label_Link"});
    
    label11.GetDom().onclick = function()
    {
        CommonDialog.Confirm("更新后您原有的链接将失效，你确定要更新链接吗？", This.GetTopContainer(),
        function()
        {
            This.GetTopContainer().Waiting("");
            try
            {
                Management.Management.UpdateInviteCode(
                function(code)
                {
                    m_Info.InviteCode = code;
                    This.GetTopContainer().Completed();
                    m_EditLink.SetText(String.format("http://{0}{1}/Login.aspx?User={2}&InviteCode={3}", window.location.host, System.Path.GetDirectoryName(window.location.pathname), m_Info.Name, code));
                },
                function(error)
                {
                    This.GetTopContainer().Completed();
                    CommonDialog.Alert(error.Message, This.GetTopContainer());
                },
                m_Info.Name);
            }
            catch(ex)
            {
                This.GetTopContainer().Completed();
                CommonDialog.Alert(ex.message, This.GetTopContainer());
            }
        });
    }

    
    var m_BtnUpdate = new Controls.Button({"Left":364,"Top":285,"Width":64,"Height":26,"AnchorStyle":Controls.AnchorStyle.Right|Controls.AnchorStyle.Bottom,"Parent":This,"Text":"更新","Css":"button_default"});
    
    
    
    m_BtnUpdate.OnClick.Attach(
        function(btn)
        {
            This.GetTopContainer().Waiting("");
            try
            {
                Management.Management.UpdateUserInfo(
                function(newInfo)
                {
                    This.Load(newInfo);
                    m_Info = newInfo;
                    This.GetTopContainer().Completed();
                    This.OnChanged.Call();
                },
                function(error)
                {
                    This.GetTopContainer().Completed();
                    CommonDialog.Alert(error.Message, This.GetTopContainer());
                },
                m_Info.Name, {
                    Nickname: m_EditNickname.GetText()
                });
            }
            catch(ex)
            {
                This.GetTopContainer().Completed();
                CommonDialog.Alert(ex.message, This.GetTopContainer());
            }
        }
    )
    

    
    This.Load = function(groupInfo)
    {
        m_Info = groupInfo;
        m_EditName.SetText(groupInfo.Name);
        m_EditNickname.SetText(groupInfo.Nickname);
        m_EditCreator.SetText(groupInfo.Creator);
        if (groupInfo.InviteCode!= undefined)
        {
            m_EditLink.SetText(System.MakeInviteUrl(groupInfo.Name, groupInfo.InviteCode));
        }
        else
        {
            m_EditLink.SetText("仅群主可显示");
        }
        m_EditNickname.GetTextBoxDom().readOnly = (System.GetUser() != groupInfo.Creator);
        label11.SetVisible(System.GetUser() == groupInfo.Creator);
    }
    
    This.OnChanged = new Delegate();
    
    var m_Info = null;

    This.Resize(width,height);
}




function GroupMemberPanel(config)
{
    var This = this;
    var OwnerForm = this;
    

    
    var width = config.Width, height = config.Height;
    config.Width=412;
    config.Height=285;

    Control.call(This, config);

    var Base = {
        GetType: This.GetType,
        is: This.is
    };

    This.GetType = function() { return "GroupMemberPanel"; }
    This.is = function(type) { return type == This.GetType() ? true : Base.is(type); }
    
    var m_ListMember_Config={"Left":0,"Top":0,"Width":412,"Height":285,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top|Controls.AnchorStyle.Bottom,"Parent":This,"Text":"","Css":"listview","BorderWidth":1,"ListMode":{"HeaderHeight":28,"RowHeight":24}};
    
    m_ListMember_Config.Columns=[{"Name":"name","Text":"用户名","Width":150,"Css":"td_header_default"},{"Name":"nickname","Text":"昵称","Width":120,"Css":"td_header_default"},{"Name":"operation","Text":"","Width":120,"Css":"td_header_default"}];
    
    function m_ListMember_ListItem()
    {
        var This=this;
    
var info = arguments[0];

this.GetValue = function(columnName)
{
    if (columnName == "Name")
    {
        return info.Name;
    }
    else if (columnName == "Nickname")
    {
        return info.Nickname;
    }
}
        
        this.GetText=function(columnName)
        {
if (columnName == "name")
{
    return String.format("<div class='Image16_User' style='margin-left:2px; width: 16px; height: 16px; float:left;'></div><div class='IM_MemberList_TD_Name'>{0}</div>", info.Name);
}
else if (columnName == "nickname")
{
    return info.Nickname;
}
else if (columnName == "operation")
{
    return "<div class='IM_MemberList_Operation'>移出本群</div><div class='IM_MemberList_Operation'>加为好友</div>"
}
        }
    }
    
    var m_ListMember = new Controls.ListView(m_ListMember_Config);
    
    
    m_ListMember.OnItemDblClick.Attach(
    function(item)
    {
        Instance.StartChatWith(item.GetValue("Name"));
    });
    

    This.Load = function(groupInfo)
    {
        m_ListMember.Clear();
        for (var i in groupInfo.Members)
        {
            m_ListMember.AppendItem(new m_ListMember_ListItem(groupInfo.Members[i]));
        }
    
        var items = m_ListMember.GetAllItems();
        for (var i in items)
        {
            var cell = m_ListMember.GetCell(i, 2);
            (function(name)
            {
                cell.childNodes[0].onclick = function()
                {
                    CommonDialog.Confirm(
                    String.format('您确定要将"{0}"从本群移除?', name), This.GetTopContainer(),
                    function()
                    {
                        This.GetTopContainer().Waiting();
                        Management.Management.RemoveFromGroup(
                        function()
                        {
                            This.GetTopContainer().Completed();
                            This.OnChanged.Call();
                        },
                        function(error)
                        {
                            This.GetTopContainer().Completed();
                            CommonDialog.Alert(error.Message, This.GetTopContainer());
                        },
                        name, groupInfo.Name);
                    });
                }
                cell.childNodes[1].onclick = function()
                {
                    var form = ShowAddFriendForm();
                    form.SetInfo(0, name, "");
                }
            })(groupInfo.Members[i].Name);
        }
    }
    
    This.OnChanged = new Delegate();

    This.Resize(width,height);
}

function GroupManageForm()
{
    var This = this;
    var OwnerForm = this;
    
    var config = {"Left":20,"Top":16,"Width":440,"Height":356,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":null,"Css":"window","BorderWidth":6,"HasMinButton":false,"HasMaxButton":false,"Resizable":false,"Title":{"InnerHTML":"群管理"}};
    

    Window.call(This, config);

    var Base = {
        GetType: This.GetType,
        is: This.is
    };

    This.GetType = function() { return "GroupManageForm"; }
    This.is = function(type) { return type == This.GetType() ? true : Base.is(type); }
    
    var tab1 = new Controls.SimpleTabControl({"Left":1,"Top":1,"Width":426,"Height":324,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top|Controls.AnchorStyle.Bottom,"Parent":This,"Text":"","Css":"simple_tab","Tabs":[{"Text":"群信息","Width":80,"ID":"ID000076","IsSelected":true},{"Text":"群成员","Width":80,"ID":"ID000077","IsSelected":false},{"Text":"群消息设置","Width":100,"ID":"ID000078","IsSelected":false}],"BorderWidth":1});
    
    
    
    tab1.OnSelectedTab.Attach(
        function(index,preIndex)
        {
            
        }
    )

    
    var m_InfoPanel_Config={"Left":10,"Top":11,"Width":405,"Height":280,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top|Controls.AnchorStyle.Bottom,"Parent":tab1.GetPanel(0),"Text":"","Css":"control"};
    
            
    
    var m_InfoPanel = new GroupInfoPanel(m_InfoPanel_Config);
    
    

    
    var m_MemberPanel_Config={"Left":1,"Top":1,"Width":422,"Height":295,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top|Controls.AnchorStyle.Bottom,"Parent":tab1.GetPanel(1),"Text":"","Css":"control"};
    
            
    
    var m_MemberPanel = new GroupMemberPanel(m_MemberPanel_Config);
    
    

    
    var label5 = new Controls.Label({"Left":18,"Top":24,"Width":149,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(2),"Text":"消息中包含的文件不能超过","Css":"label"});
    
    

    
    var m_EditFileLimit = new Controls.TextBox({"Left":168,"Top":20,"Width":56,"Height":22,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(2),"Text":"","Css":"textbox","BorderWidth":1});
    
    

    
    var label7 = new Controls.Label({"Left":228,"Top":24,"Width":60,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(2),"Text":"KB","Css":"label"});
    
    

    
    var label8 = new Controls.Label({"Left":18,"Top":60,"Width":148,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(2),"Text":"消息中包含的图片不能超过","Css":"label"});
    
    

    
    var m_EditImageLimit = new Controls.TextBox({"Left":168,"Top":56,"Width":56,"Height":22,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(2),"Text":"","Css":"textbox","BorderWidth":1});
    
    

    
    var label10 = new Controls.Label({"Left":228,"Top":60,"Width":60,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(2),"Text":"KB","Css":"label"});
    
    

    
    var button11 = new Controls.Button({"Left":347,"Top":262,"Width":64,"Height":26,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(2),"Text":"更新","Css":"button_default"});
    
    
    
    button11.OnClick.Attach(
        function(btn)
        {
            This.Waiting("");
            try
            {
                Management.Management.UpdateUserInfo(
                function(newInfo)
                {
                    m_EditFileLimit.GetTextBoxDom().readOnly = (System.GetUser().toUpperCase() != newInfo.Creator.toUpperCase());
                    m_EditImageLimit.GetTextBoxDom().readOnly = (System.GetUser().toUpperCase() != newInfo.Creator.toUpperCase());
                    button11.SetVisible(System.GetUser().toUpperCase() == newInfo.Creator.toUpperCase());
            
                    m_EditFileLimit.SetText(newInfo.MsgFileLimit);
                    m_EditImageLimit.SetText(newInfo.MsgImageLimit);
            
                    This.Completed();
                },
                function(error)
                {
                    This.Completed();
                    CommonDialog.Alert(error.Message, This);
                },
                name, {
                    MsgFileLimit: parseInt(m_EditFileLimit.GetText()),
                    MsgImageLimit: parseInt(m_EditImageLimit.GetText())
                });
            }
            catch(ex)
            {
                This.Completed();
                CommonDialog.Alert(ex.message, This);
            }
        }
    )
    

    var m_Task = null;
    if(config.HasMinButton)
    {
        m_Task=Taskbar.AddTask(This,IsNull(config.Title.InnerHTML,""));
        This.OnClosed.Attach(
            function()
            {
                Taskbar.RemoveTask(m_Task);
            }
        );
    }
    This.SelectTab = function(index)
    {
        tab1.Select(index);
    }
    
    This.Load = function()
    {
        This.Waiting("");
        try
        {
            Management.Management.GetUserInfo(
            function(info)
            {
                m_EditFileLimit.GetTextBoxDom().readOnly = (System.GetUser().toUpperCase() != info.Creator.toUpperCase());
                m_EditImageLimit.GetTextBoxDom().readOnly = (System.GetUser().toUpperCase() != info.Creator.toUpperCase());
                button11.SetVisible(System.GetUser().toUpperCase() == info.Creator.toUpperCase());
    
                m_EditFileLimit.SetText(info.MsgFileLimit);
                m_EditImageLimit.SetText(info.MsgImageLimit);
    
                This.SetTitle(String.format("群管理 - {1}({0})", info.Name, info.Nickname));
                m_InfoPanel.Load(info);
                m_MemberPanel.Load(info);
    
                This.Completed();
            },
            function(error)
            {
                This.Completed();
                CommonDialog.Alert(error.Message, This);
            },
            name);
        }
        catch(ex)
        {
            This.Completed();
            CommonDialog.Alert(ex.message, This);
        }
    }
    
    m_InfoPanel.OnChanged.Attach(
    function()
    {
        This.Load();
    });
    
    m_MemberPanel.OnChanged.Attach(
    function()
    {
        This.Load();
    });
    
    var name = arguments[0];
    setTimeout(This.Load, 10);
}


function MsgUserTreeDS()
{
    this.GetSubNodes = function(callback, node)
    {
        if (node == null)
        {
            var nodes = [{
                Name: "Users",
                Text: "联系人",
                Tag: null,
                ImageCss: "Image16_Folder"
            },
            {
                Name: "Groups",
                Text: "群",
                Tag: null,
                ImageCss: "Image16_Folder"
            },
            {
                Name: "Strangers",
                Text: "陌生人",
                Tag: null,
                ImageCss: "Image16_Folder"
            }];
            callback(nodes);
        }
        else
        {
            var name = node.GetName();
            if (name != "Users" && name != "Groups" && name != "Strangers")
            {
                callback([]);
                return;
            }

            if (name == "Strangers")
            {
                Communication.Communication.GetAllSenders(
                function(senders)
                {
                    var nodes = [];
                    for (var k in senders)
                    {
                        var sender = senders[k];

                        if (sender.Type == 0 && FriendManager.GetFriendInfo(sender.Name) == undefined)
                        {
                            nodes.push({
                                Name: sender.Name,
                                Text: String.format("{0}({1})", sender.Nickname, sender.Name),
                                Tag: sender,
                                HasChildren: false,
                                ImageCss: "Image16_User"
                            });
                        }
                    }
                    callback(nodes);
                },
                function(ex)
                {
                    callback(ex);
                },
                System.GetUser());
            }
            else if (name == "Users")
            {
                var friends = FriendManager.GetAllFriends();
                var nodes = [];
                for (var k in friends)
                {
                    var friend = friends[k];
                    if (friend.Type == 0)
                    {
                        nodes.push({
                            Name: friend.Name,
                            Text: String.format("{0}({1})", friend.Nickname, friend.Name),
                            Tag: friend,
                            HasChildren: false,
                            ImageCss: "Image16_User"
                        });
                    }
                }
                callback(nodes);
            }
            else
            {
                var friends = FriendManager.GetAllFriends();
                var nodes = [];
                for (var k in friends)
                {
                    var friend = friends[k];
                    if (friend.Type == 1)
                    {
                        nodes.push({
                            Name: friend.Name,
                            Text: String.format("{0}({1})", friend.Nickname, friend.Name),
                            Tag: friend,
                            HasChildren: false,
                            ImageCss: "Image16_Group"
                        });
                    }
                }
                callback(nodes);
            }
        }
    }
}

function MsgUserTree(config)
{
    var This = this;
    var OwnerForm = this;
    
config.DataSource = new MsgUserTreeDS();
    
    var width = config.Width, height = config.Height;
    config.Width=210;
    config.Height=512;

    Controls.TreeView.call(This, config);

    var Base = {
        GetType: This.GetType,
        is: This.is
    };

    This.GetType = function() { return "MsgUserTree"; }
    This.is = function(type) { return type == This.GetType() ? true : Base.is(type); }
    

    

    This.Resize(width,height);
}

