if(!TESTING)
{
    System.Link("StyleSheet", Module.GetResourceUrl("Setting.css"), "text/css");
}

var Controls = null, CommonDialog = null, IO = null, Communication = null, Management = null;
var Window = null, Control = null, RichEditor = null;

function init(completeCallback, errorCallback)
{
    function LoadModulesComplete()
    {
        IO = System.GetModule("IO.js");
        Communication = System.GetModule("Communication.js");
        Management = System.GetModule("Management.js");
        Controls = System.GetModule("Controls.js");
        CommonDialog = System.GetModule("CommonDialog.js");

        Window = System.GetModule("Window.js").Window;
        Control = System.GetModule("Controls.js").Control;
        
        RichEditor = System.GetModule("RichEditor.js").RichEditor;

        _init(completeCallback, errorCallback);
    }

    System.LoadModules(
        LoadModulesComplete,
        errorCallback,
        ["IO.js", "Communication.js", "Management.js", "Window.js", "Controls.js", "CommonDialog.js", "RichEditor.js"]
    );
}

function _init(completeCallback, errorCallback)
{
    try
    {
        //初始化代码，初始化完成后必须调用completeCallback;
        completeCallback();
    }
    catch (ex)
    {
        errorCallback(new Exception(ex.mame, ex.message));
    }
}



function dispose(completeCallback, errorCallback)
{
    _dispose(completeCallback, errorCallback);
}

function _dispose(completeCallback, errorCallback)
{
    try
    {
        //卸载代码，卸载完成后必须调用completeCallback;
        completeCallback();
    }
    catch (ex)
    {
        errorCallback(new Exception(ex.mame, ex.message));
    }
}

//共享全局变量和函数，在此定义的变量和函数将由该应用程序的所有实例共享
var Instance = null;

function Application()
{
    var CurrentApplication = this;
    var m_MainForm = null;
    
    //应用程序全局对象;
    CurrentApplication.ShowMainForm = function()
    {
        m_MainForm.Show(true);
    }    

    this.Start = function(baseUrl)
    {
        //应用程序入口;
        if (Instance == null)
        {
            Instance = CurrentApplication;
        
            m_MainForm = new MainForm();
            m_MainForm.OnClosed.Attach(
            function()
            {
                CurrentApplication.Dispose();
                Instance = null;
            });
            m_MainForm.MoveEx("center", 0, 0);
            m_MainForm.Show(true);
        }
        else
        {
            Instance.ShowMainForm();
        }
    }

    this.Terminate = function(completeCallback, errorCallback)
    {
        try
        {
            //应用程序终止，退出系统时用系统调用;
            completeCallback();
        }
        catch (ex)
        {
            errorCallback(new Exception(ex.mame, ex.message));
        }
    }
    function MainForm()
    {
        var This = this;
        var OwnerForm = this;
        
        var config = {"Left":9,"Top":15,"Width":430,"Height":330,"AnchorStyle":Controls.AnchorStyle.Left | Controls.AnchorStyle.Top,"Parent":null,"Css":"window","BorderWidth":6,"HasMinButton":false,"HasMaxButton":false,"Resizable":false,"Title":{"InnerHTML":"系统设置"}};
        
    
        Window.call(This, config);
    
        var Base = {
            GetType: This.GetType,
            is: This.is
        };
    
        This.GetType = function() { return "MainForm"; }
        This.is = function(type) { return type == This.GetType() ? true : Base.is(type); }
        
        var tab1 = new Controls.SimpleTabControl({"Left":1,"Top":1,"Width":416,"Height":298,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top|Controls.AnchorStyle.Bottom,"Parent":This,"Text":"","Css":"simple_tab","Tabs":[{"Text":"个人信息","Width":100,"ID":"ID000062","IsSelected":true},{"Text":"消息设置","Width":100,"ID":"ID000063","IsSelected":false}],"BorderWidth":1});
        
        
        
        tab1.OnSelectedTab.Attach(
            function(index,preIndex)
            {
                
            }
        )

        
        var label2 = new Controls.Label({"Left":34,"Top":42,"Width":40,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(0),"Text":"昵称：","Css":"label"});
        
        

        
        var m_EditNickname = new Controls.TextBox({"Left":77,"Top":38,"Width":329,"Height":22,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(0),"Text":"","Css":"textbox","BorderWidth":1});
        
        

        
        var m_EditEMail = new Controls.TextBox({"Left":77,"Top":65,"Width":329,"Height":22,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(0),"Text":"","Css":"textbox","BorderWidth":1});
        
        

        
        var label5 = new Controls.Label({"Left":10,"Top":70,"Width":63,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(0),"Text":"电子邮件：","Css":"label"});
        
        

        
        var label6 = new Controls.Label({"Left":11,"Top":123,"Width":63,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(0),"Text":"邀请链接：","Css":"label"});
        
        

        
        var label7 = new Controls.Label({"Left":77,"Top":123,"Width":300,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(0),"Text":"(通过以下链接登录或注册的用户将同时添加您为好友)","Css":"Setting_Label_Blue"});
        
        

        
        var label8 = new Controls.Label({"Left":379,"Top":123,"Width":26,"Height":14,"AnchorStyle":Controls.AnchorStyle.Right|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(0),"Text":"更新","Css":"Setting_Label_Link"});
        
        label8.GetDom().onclick=function()
        {
            CommonDialog.Confirm("更新后您原有的链接将失效，你确定要更新链接吗？", This,
            function()
            {
                This.Waiting("");
                Management.Management.UpdateInviteCode(
                function(code)
                {
                    This.Completed();
                    m_EditInviteCode.SetText(String.format("http://{0}{1}/Login.aspx?User={2}&InviteCode={3}", window.location.host, System.Path.GetDirectoryName(window.location.pathname), System.GetUser(), code));
                },
                function(error)
                {
                    This.Completed();
                    CommonDialog.Alert(error.Message, This);
                });
            });
        }

        
        var m_EditInviteCode = new Controls.TextArea({"Left":10,"Top":143,"Width":396,"Height":90,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Right|Controls.AnchorStyle.Top|Controls.AnchorStyle.Bottom,"Parent":tab1.GetPanel(0),"Text":"","Css":"textarea","BorderWidth":1});
        
        m_EditInviteCode.GetTextAreaDom().readOnly = true;

        
        var button10 = new Controls.Button({"Left":342,"Top":240,"Width":64,"Height":26,"AnchorStyle":Controls.AnchorStyle.Right|Controls.AnchorStyle.Bottom,"Parent":tab1.GetPanel(0),"Text":"更新","Css":"button_default"});
        
        
        
        button10.OnClick.Attach(
            function(btn)
            {
                This.Waiting("");
                try
                {
                    Management.Management.UpdateUserInfo(
                    function(newInfo)
                    {
                        Desktop.Navigate(newInfo.HomePage);
                        ShowInfo(newInfo);
                        This.Completed();
                    },
                    function(error)
                    {
                        This.Completed();
                        CommonDialog.Alert(error.Message, This);
                    },
                    System.GetUser(), {
                        Nickname: m_EditNickname.GetText(),
                        EMail: m_EditEMail.GetText(),
                        HomePage: m_EditHomePage.GetText()
                    });
                }
                catch(ex)
                {
                    This.Completed();
                    CommonDialog.Alert(ex.message, This);
                }
            }
        )

        
        var button11 = new Controls.Button({"Left":244,"Top":240,"Width":90,"Height":26,"AnchorStyle":Controls.AnchorStyle.Right|Controls.AnchorStyle.Bottom,"Parent":tab1.GetPanel(0),"Text":"修改密码","Css":"button"});
        
        
        
        button11.OnClick.Attach(
            function(btn)
            {
                var form = new ChangePasswordForm();
                form.ShowDialog(This, "center", 0, 0);
            }
        )

        
        var m_EditName = new Controls.TextBox({"Left":77,"Top":10,"Width":329,"Height":22,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(0),"Text":"","Css":"textbox","BorderWidth":1});
        
        m_EditName.GetTextBoxDom().readOnly = true;

        
        var label13 = new Controls.Label({"Left":22,"Top":15,"Width":51,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(0),"Text":"用户名：","Css":"label"});
        
        

        
        var label24 = new Controls.Label({"Left":34,"Top":97,"Width":38,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(0),"Text":"首页：","Css":"label"});
        
        

        
        var m_EditHomePage = new Controls.TextBox({"Left":77,"Top":93,"Width":329,"Height":22,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(0),"Text":"","Css":"textbox","BorderWidth":1});
        
        

        
        var m_CheckAcceptStrangeIM = new Controls.CheckBox({"Left":16,"Top":17,"Width":381,"Height":20,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(1),"Text":"接收陌生人发送的即时消息","Css":"checkbox","BorderWidth":1});
        
        

        
        var button16 = new Controls.Button({"Left":342,"Top":240,"Width":64,"Height":26,"AnchorStyle":Controls.AnchorStyle.Right|Controls.AnchorStyle.Bottom,"Parent":tab1.GetPanel(1),"Text":"更新","Css":"button_default"});
        
        
        
        button16.OnClick.Attach(
            function(btn)
            {
                This.Waiting("");
                try
                {
                    Management.Management.UpdateUserInfo(
                    function(newInfo)
                    {
                        ShowInfo(newInfo);
                        This.Completed();
                    },
                    function(error)
                    {
                        This.Completed();
                        CommonDialog.Alert(error.Message, This);
                    },
                    System.GetUser(), {
                        AcceptStrangerIM: m_CheckAcceptStrangeIM.GetCheckBoxDom().checked,
                        MsgFileLimit: parseInt(m_EditFileLimit.GetText()),
                        MsgImageLimit: parseInt(m_EditImageLimit.GetText())
                    });
                }
                catch(ex)
                {
                    This.Completed();
                    CommonDialog.Alert(ex.message, This);
                }
            }
        )

        
        var label17 = new Controls.Label({"Left":17,"Top":50,"Width":148,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(1),"Text":"消息中包含的文件不能超过","Css":"label"});
        
        

        
        var m_EditFileLimit = new Controls.TextBox({"Left":168,"Top":46,"Width":54,"Height":22,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(1),"Text":"","Css":"textbox","BorderWidth":1});
        
        

        
        var label20 = new Controls.Label({"Left":226,"Top":51,"Width":56,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(1),"Text":"KB","Css":"label"});
        
        

        
        var label21 = new Controls.Label({"Left":17,"Top":85,"Width":147,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(1),"Text":"消息中包含的图片不能超过","Css":"label"});
        
        

        
        var m_EditImageLimit = new Controls.TextBox({"Left":168,"Top":81,"Width":54,"Height":22,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(1),"Text":"","Css":"textbox","BorderWidth":1});
        
        

        
        var label23 = new Controls.Label({"Left":226,"Top":85,"Width":55,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":tab1.GetPanel(1),"Text":"KB","Css":"label"});
        
        
    
    
        var m_Task = null;
        if(config.HasMinButton)
        {
            m_Task=Taskbar.AddTask(This,IsNull(config.Title.InnerHTML,""));
            This.OnClosed.Attach(
                function()
                {
                    Taskbar.RemoveTask(m_Task);
                }
            );
        }
        function ShowInfo(info)
        {
            m_EditName.SetText(info.Name);
            m_EditNickname.SetText(info.Nickname);
            m_EditEMail.SetText(info.EMail);
            m_EditHomePage.SetText(info.HomePage);
            m_EditInviteCode.SetText(System.MakeInviteUrl(System.GetUser(), info.InviteCode));
        
            m_CheckAcceptStrangeIM.GetCheckBoxDom().checked = info.AcceptStrangerIM;
            m_EditFileLimit.SetText(info.MsgFileLimit);
            m_EditImageLimit.SetText(info.MsgImageLimit);
        }
        
        function LoadUserInfo()
        {
            This.Waiting("");
            try
            {
                Management.Management.GetUserInfo(
                function(info)
                {
                    ShowInfo(info);
                    This.Completed();
                },
                function(error)
                {
                    This.Completed();
                    CommonDialog.Alert(error.Message, This);
                },
                System.GetUser());
            }
            catch(ex)
            {
                This.Completed();
                CommonDialog.Alert(ex.message, This);
            }
        }
        
        setTimeout(LoadUserInfo, 10);
    }

}
function ChangePasswordForm()
{
    var This = this;
    var OwnerForm = this;
    
    var config = {"Left":18,"Top":8,"Width":300,"Height":183,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":null,"Css":"window","BorderWidth":6,"HasMinButton":false,"HasMaxButton":false,"Resizable":false,"Title":{"InnerHTML":"修改密码"}};
    

    Window.call(This, config);

    var Base = {
        GetType: This.GetType,
        is: This.is
    };

    This.GetType = function() { return "ChangePasswordForm"; }
    This.is = function(type) { return type == This.GetType() ? true : Base.is(type); }
    
    var label2 = new Controls.Label({"Left":17,"Top":19,"Width":53,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":This,"Text":"原密码：","Css":"label"});
    
    

    
    var label3 = new Controls.Label({"Left":18,"Top":52,"Width":50,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":This,"Text":"新密码：","Css":"label"});
    
    

    
    var label4 = new Controls.Label({"Left":6,"Top":85,"Width":62,"Height":14,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":This,"Text":"密码确认：","Css":"label"});
    
    

    
    var m_PwdPrevious = new Controls.PasswordBox({"Left":75,"Top":15,"Width":205,"Height":22,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":This,"Text":"","Css":"textbox","BorderWidth":1});
    
    

    
    var m_PwdNew = new Controls.PasswordBox({"Left":75,"Top":48,"Width":204,"Height":22,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":This,"Text":"","Css":"textbox","BorderWidth":1});
    
    

    
    var m_PwdNewConfirm = new Controls.PasswordBox({"Left":75,"Top":81,"Width":204,"Height":22,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":This,"Text":"","Css":"textbox","BorderWidth":1});
    
    

    
    var button8 = new Controls.Button({"Left":214,"Top":115,"Width":64,"Height":26,"AnchorStyle":Controls.AnchorStyle.Left|Controls.AnchorStyle.Top,"Parent":This,"Text":"确定","Css":"button_default"});
    
    
    
    button8.OnClick.Attach(
        function(btn)
        {
            if (m_PwdPrevious.GetText() == "")
            {
                CommonDialog.Alert("请输入原密码！", This);
                return;
            }
            if (m_PwdNew.GetText() == "")
            {
                CommonDialog.Alert("请输入新密码！", This);
                return;
            }
            if (m_PwdNewConfirm.GetText() != m_PwdNew.GetText())
            {
                CommonDialog.Alert("两次输入的密码不一致！", This);
                return;
            }
            
            This.Waiting("");
            try
            {
                Management.Management.UpdateUserInfo(
                function()
                {
                    This.Completed();
                    This.Close();
                },
                function(error)
                {
                    This.Completed();
                    CommonDialog.Alert(error.Message, This);
                },
                System.GetUser(), {
                    Password: m_PwdNew.GetText(),
                    PreviousPassword: m_PwdPrevious.GetText()
                });
            }
            catch(ex)
            {
                This.Completed();
                CommonDialog.Alert(ex.message, This);
            }
        }
    )
    

    var m_Task = null;
    if(config.HasMinButton)
    {
        m_Task=Taskbar.AddTask(This,IsNull(config.Title.InnerHTML,""));
        This.OnClosed.Attach(
            function()
            {
                Taskbar.RemoveTask(m_Task);
            }
        );
    }
    
}

